// Dragon Code Decoder
// Version: 0.85
// COPYRIGHT 2000 Amthrax Arlan

#include <windows.h>
#include <stdio.h>
#include "resource.h"

#define TRAY_NOTIFYICON		(WM_APP+100)

HINSTANCE ghInst;
HWND ghWnd;
HICON StatusIcons[5];
int CurrentStatus;
char CurrentTip[64];
BOOL OptionsDialogOpen,AboutDialogOpen,EnterDC2DialogOpen;
BOOL MonitorClipboard,AutoClipMultiLine,DontAutohide;
int HideDelay,AppendDelay;
char CurCode[8192];
char output[10*1024];

void AddTaskbarIcons(void);
void SetTaskbarIcon(int state, char tip[]);
BOOL TrayMessage(HWND hwnd, DWORD msg, UINT id, HICON hIcon, PTSTR tip);
void TrayIconDelete(HWND hwnd, UINT id, HICON hIcon);
void TrayIconModify(HWND hwnd, UINT id, HICON hIcon, PTSTR tip);
void TrayIconAdd(HWND hwnd, UINT id, HICON hIcon, PTSTR tip);

void DCDecode(char in[], char *out, int forcever=0);

int GetTextWidth(HDC hdc, char text[], int textlen)
{
	SIZE size;
	GetTextExtentPoint(hdc,text,textlen,&size);
	return size.cx;
}

int GetTextHeight(HDC hdc, char text[], int textlen)
{
	SIZE size;
	GetTextExtentPoint(hdc,text,textlen,&size);
	return size.cy;
}

#define MAXWIDTH	400

void OutputText(HDC hdc, SIZE *osize)
{
	char line[514];
	unsigned int outpos,linepos,wordbeginout,wordbeginline,tabpos;
	unsigned int tabposes[10]={10,18,26,34,42,50,58,66,74};
	int i,cury;

	// Format the output, ugh (doesn't work very cleanly, but appears to at least work)
	outpos=0;
	tabpos=0;
	cury=0;
	for (i=0;i<10;i++)
		tabposes[i]=i*30+75;
	if (osize)
		osize->cx=osize->cy=0;
	while(outpos<strlen(output))
	{
		linepos=0;
//		for (linepos=0;linepos<tabpos;linepos++)
//			line[linepos]=' ';
		while(GetTextWidth(hdc,line,linepos)+tabpos<MAXWIDTH&&linepos<512&&outpos<strlen(output))
		{
			// Get the next word
			wordbeginout=outpos;
			wordbeginline=linepos;
			while(!iswspace(output[outpos])&&GetTextWidth(hdc,line,linepos)+tabpos<MAXWIDTH&&linepos<512&&outpos<strlen(output))
			{
				line[linepos++]=output[outpos++];
				if (GetTextWidth(hdc,line,linepos)+tabpos>MAXWIDTH||linepos>=512)	// Word went over
				{
					line[wordbeginline]=0;
					outpos=wordbeginout-1;
					linepos=1000;
				}
			}
			// Just in case
			if (GetTextWidth(hdc,line,linepos)+tabpos>MAXWIDTH||linepos>=512)	// Word went over
			{
				line[wordbeginline]=0;
				outpos=wordbeginout-1;
				linepos=1000;
			}
			if (output[outpos]=='\n')
			{
				TextOut(hdc,tabpos,cury,line,linepos);
				cury+=GetTextHeight(hdc,line,linepos);
				if (osize)
					if (GetTextWidth(hdc,line,linepos)+(signed)tabpos>osize->cx)
						osize->cx=GetTextWidth(hdc,line,linepos)+tabpos;
				tabpos=0;
				linepos=-1;
			} else if (output[outpos]=='\t') {
				tabpos=tabposes[0];
				for(i=0;i<10;i++)
					if ((signed)tabposes[i]>GetTextWidth(hdc,line,linepos)+15)
					{
						tabpos=tabposes[i];
						break;
					}
				TextOut(hdc,0,cury,line,linepos);
				linepos=-1;
//				for(;linepos<tabpos;linepos++)
//					line[linepos]=' ';
//				linepos--;
			}/* else if (linepos==1000) {
				TextOut(hdc,tabpos,cury,line,strlen(line));
				cury+=GetTextHeight(hdc,line,strlen(line));
				if (osize)
					if (GetTextWidth(hdc,line,strlen(line))+(signed)tabpos>osize->cx)
						osize->cx=GetTextWidth(hdc,line,strlen(line))+tabpos;
				linepos=-1;
			}*/ else
				line[linepos]=output[outpos];
			linepos++;
			outpos++;
			line[linepos]=0;
		}
		while(outpos<strlen(output)&&iswspace(output[outpos])&&output[outpos]!='\n') outpos++;
		if (output[outpos]=='\n')
		{
			outpos++;		// No blank newlines
			tabpos=0;
		}
		TextOut(hdc,tabpos,cury,line,strlen(line));
		cury+=GetTextHeight(hdc,line,strlen(line));
		if (osize)
			if (GetTextWidth(hdc,line,strlen(line))+(signed)tabpos>osize->cx)
				osize->cx=GetTextWidth(hdc,line,strlen(line))+tabpos;
		//linepos=-1;
	}
	if (osize)
		osize->cy=cury;
}

void RunCode(char code[], BOOL donthide)
{
	HWND prevwindow;
	HDC hdc;
	SIZE osize;
	RECT warect;
	unsigned int pos,cpos;

	if (strnicmp(code,"DC2.",4)==0||strnicmp(code,"DC.",3)==0)
		pos=0;
	else
		pos=strlen(CurCode);

	// Run through code and strip returns
	cpos=0;
	while (cpos<strlen(code))
	{
		if (code[cpos]=='\n'||code[cpos]=='\r')
		{
			cpos++;
			if (AutoClipMultiLine)
			{
				while (cpos<strlen(code)&&!isalpha(code[cpos])) cpos++;
			}
		} else {
			CurCode[pos++]=code[cpos++];
		}
	}
	CurCode[pos]=0;

	if (strnicmp(CurCode,"DC2.",4)&&strnicmp(CurCode,"DC.",3)&&!donthide)
		return;

	strcpy(output,"");
	DCDecode(CurCode,output);

	// Get the size of the text
	hdc=GetDC(ghWnd);
	OutputText(hdc,&osize);
	ReleaseDC(ghWnd,hdc);
	SystemParametersInfo(SPI_GETWORKAREA,0,(PVOID)&warect,0);
	SetWindowPos(ghWnd,NULL,warect.right-osize.cx,warect.bottom-osize.cy,osize.cx,osize.cy,SWP_NOZORDER);
	prevwindow=GetActiveWindow();
	ShowWindow(ghWnd,SW_SHOW);
	if (prevwindow!=ghWnd&&!donthide)
		SetActiveWindow(prevwindow);
	KillTimer(ghWnd,1);
	KillTimer(ghWnd,2);
	if (HideDelay&&!donthide)
	{
		SetTimer(ghWnd,1,HideDelay*1000,NULL);
	}
	if (AppendDelay&&!donthide)
	{
		SetTimer(ghWnd,2,AppendDelay*1000,NULL);
	} else {
		strcpy(CurCode,"");
	}
}

BOOL CALLBACK OptionsProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	HKEY key;
	int itemp;
	char ctemp[100];
	switch (uMsg)
	{
	case WM_INITDIALOG:
		OptionsDialogOpen=TRUE;
		if (MonitorClipboard)
			CheckDlgButton(hwndDlg,IDC_MONITOR,BST_CHECKED);
		else
			CheckDlgButton(hwndDlg,IDC_MONITOR,BST_UNCHECKED);
		sprintf(ctemp,"%d",HideDelay);
		SetDlgItemText(hwndDlg,IDC_HIDEDELAY,ctemp);
		sprintf(ctemp,"%d",AppendDelay);
		SetDlgItemText(hwndDlg,IDC_APPENDDELAY,ctemp);
		if (AutoClipMultiLine)
			CheckDlgButton(hwndDlg,IDC_AUTOCLIP,BST_CHECKED);
		else
			CheckDlgButton(hwndDlg,IDC_AUTOCLIP,BST_UNCHECKED);
		if (DontAutohide)
			CheckDlgButton(hwndDlg,IDC_DONTAUTOHIDE,BST_CHECKED);
		else
			CheckDlgButton(hwndDlg,IDC_DONTAUTOHIDE,BST_UNCHECKED);
		if (IsDlgButtonChecked(hwndDlg,IDC_MONITOR))
		{
			EnableWindow(GetDlgItem(hwndDlg,IDC_HIDEDELAY),TRUE);
			EnableWindow(GetDlgItem(hwndDlg,IDC_APPENDDELAY),TRUE);
		} else {
			EnableWindow(GetDlgItem(hwndDlg,IDC_HIDEDELAY),FALSE);
			EnableWindow(GetDlgItem(hwndDlg,IDC_APPENDDELAY),FALSE);
		}
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDOK:
			if (RegCreateKeyEx(HKEY_CURRENT_USER,"Software\\Consice\\DCDecoder\\",0,NULL,0,KEY_ALL_ACCESS,NULL,&key,NULL)==ERROR_SUCCESS)
			{
				itemp=0;
				if (IsDlgButtonChecked(hwndDlg,IDC_MONITOR))
					itemp=1;
				RegSetValueEx(key,"MonitorClipboard",0,REG_DWORD,(unsigned char*)&itemp,sizeof(int));
				MonitorClipboard=itemp;

				GetDlgItemText(hwndDlg,IDC_HIDEDELAY,ctemp,100);
				itemp=atoi(ctemp);
				RegSetValueEx(key,"HideDelay",0,REG_DWORD,(unsigned char*)&itemp,sizeof(int));
				HideDelay=itemp;

				GetDlgItemText(hwndDlg,IDC_APPENDDELAY,ctemp,100);
				itemp=atoi(ctemp);
				RegSetValueEx(key,"AppendDelay",0,REG_DWORD,(unsigned char*)&itemp,sizeof(int));
				AppendDelay=itemp;

				itemp=0;
				if (IsDlgButtonChecked(hwndDlg,IDC_AUTOCLIP))
					itemp=1;
				RegSetValueEx(key,"AutoClipMultiLine",0,REG_DWORD,(unsigned char*)&itemp,sizeof(int));
				AutoClipMultiLine=itemp;

				itemp=0;
				if (IsDlgButtonChecked(hwndDlg,IDC_DONTAUTOHIDE))
					itemp=1;
				RegSetValueEx(key,"DontAutohide",0,REG_DWORD,(unsigned char*)&itemp,sizeof(int));
				DontAutohide=itemp;
				
				RegCloseKey(key);
			} else {
				MessageBox(hwndDlg,"Error saving settings","Error",MB_OK);
			}
		case IDCANCEL:
			OptionsDialogOpen=FALSE;
			EndDialog(hwndDlg,1);
			break;
		case IDC_MONITOR:
			if (HIWORD(wParam)==BN_CLICKED)
			{
				if (IsDlgButtonChecked(hwndDlg,IDC_MONITOR))
				{
					EnableWindow(GetDlgItem(hwndDlg,IDC_HIDEDELAY),TRUE);
					EnableWindow(GetDlgItem(hwndDlg,IDC_APPENDDELAY),TRUE);
				} else {
					EnableWindow(GetDlgItem(hwndDlg,IDC_HIDEDELAY),FALSE);
					EnableWindow(GetDlgItem(hwndDlg,IDC_APPENDDELAY),FALSE);
				}
			}
			break;
		}
		break;
	case WM_CLOSE:
		OptionsDialogOpen=FALSE;
		EndDialog(hwndDlg,1);
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

BOOL CALLBACK AboutProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		AboutDialogOpen=TRUE;
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
			AboutDialogOpen=FALSE;
			EndDialog(hwndDlg,1);
			break;
		}
		break;
	case WM_CLOSE:
		AboutDialogOpen=FALSE;
		EndDialog(hwndDlg,1);
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

BOOL CALLBACK EnterDC2Proc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	char in[8192];
	switch (uMsg)
	{
	case WM_INITDIALOG:
		EnterDC2DialogOpen=TRUE;
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
			GetDlgItemText(hwndDlg,IDC_DC,in,8192);
			RunCode(in,TRUE);
		case IDCANCEL:
			EnterDC2DialogOpen=FALSE;
			EndDialog(hwndDlg,1);
			break;
		}
		break;
	case WM_CLOSE:
		EnterDC2DialogOpen=FALSE;
		EndDialog(hwndDlg,1);
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

LRESULT CALLBACK WndProc(HWND hWnd,
						UINT message,
						WPARAM wParam,
						LPARAM lParam)
{
	static UINT s_uTaskbarRestart;
	static HICON hPin;
	static BOOL ShowingPin;
	static HWND hwndNextViewer;
	HKEY key;
	DWORD foo;
	int itemp;
	HDC hdc;

	switch(message)
	{
	case WM_CREATE:
		s_uTaskbarRestart = RegisterWindowMessage(TEXT("TaskbarCreated"));
		// Setup the tray icon
		StatusIcons[0]=(HICON)LoadImage(ghInst,MAKEINTRESOURCE(IDI_MAIN),IMAGE_ICON,16,16,0);
/*		StatusIcons[1]=(HICON)LoadImage(ghInst,MAKEINTRESOURCE(IDI_TRANS),IMAGE_ICON,16,16,0);
		StatusIcons[2]=(HICON)LoadImage(ghInst,MAKEINTRESOURCE(IDI_TSEEK),IMAGE_ICON,16,16,0);
		StatusIcons[3]=(HICON)LoadImage(ghInst,MAKEINTRESOURCE(IDI_TCOLLET),IMAGE_ICON,16,16,0);
		StatusIcons[4]=(HICON)LoadImage(ghInst,MAKEINTRESOURCE(IDI_TSYNC),IMAGE_ICON,16,16,0);*/
		CurrentStatus=0;
		strcpy(CurrentTip,"Dragon Code Decoder");
		ghWnd=hWnd;		// AddTaskbarIcons needs this
		AddTaskbarIcons();
		hPin=(HICON)LoadImage(ghInst,MAKEINTRESOURCE(IDI_PIN),IMAGE_ICON,32,32,LR_DEFAULTSIZE);
		strcpy(output,"");
		strcpy(CurCode,"");
		if (RegOpenKeyEx(HKEY_CURRENT_USER,"Software\\Consice\\DCDecoder\\",0,KEY_ALL_ACCESS,&key)==ERROR_SUCCESS)
		{
			foo=sizeof(int);
			if (RegQueryValueEx(key,"MonitorClipboard",0,NULL,(unsigned char*)&itemp,&foo)!=ERROR_SUCCESS)
				itemp=1;
			if (itemp)
				MonitorClipboard=TRUE;
			else
				MonitorClipboard=FALSE;

			foo=sizeof(int);
			if (RegQueryValueEx(key,"HideDelay",0,NULL,(unsigned char*)&HideDelay,&foo)!=ERROR_SUCCESS)
				HideDelay=45;

			foo=sizeof(int);
			if (RegQueryValueEx(key,"AppendDelay",0,NULL,(unsigned char*)&AppendDelay,&foo)!=ERROR_SUCCESS)
				AppendDelay=30;

			foo=sizeof(int);
			if (RegQueryValueEx(key,"AutoClipMultiLine",0,NULL,(unsigned char*)&itemp,&foo)!=ERROR_SUCCESS)
				itemp=1;
			if (itemp)
				AutoClipMultiLine=TRUE;
			else
				AutoClipMultiLine=FALSE;

			foo=sizeof(int);
			if (RegQueryValueEx(key,"DontAutohide",0,NULL,(unsigned char*)&itemp,&foo)!=ERROR_SUCCESS)
				itemp=0;
			if (itemp)
				DontAutohide=TRUE;
			else
				DontAutohide=FALSE;
			RegCloseKey(key);
		} else {
			MonitorClipboard=TRUE;
			HideDelay=45;
			AppendDelay=30;
			AutoClipMultiLine=TRUE;
			DontAutohide=FALSE;
		}
		hwndNextViewer=SetClipboardViewer(hWnd);
		break;	// WM_CREATE

	case WM_DESTROY:
		ChangeClipboardChain(hWnd,hwndNextViewer);
		TrayIconDelete(hWnd,1,StatusIcons[CurrentStatus]);
		DestroyIcon(hPin);
		PostQuitMessage(0);
		break;	// WM_DESTROY

	case WM_PAINT:
		hdc=GetDC(hWnd);
		SetBkColor(hdc,RGB(255,255,192));
		OutputText(hdc,NULL);
		//TextOut(hdc,0,0,output,strlen(output));
		ReleaseDC(hWnd,hdc);
		ValidateRect(hWnd,NULL);
		ShowingPin=FALSE;
		break;

	case WM_CHANGECBCHAIN:
		if ((HWND)wParam==hwndNextViewer)
			hwndNextViewer=(HWND)lParam;
		else if (hwndNextViewer)
			SendMessage(hwndNextViewer,message,wParam,lParam);
		break;

	case WM_DRAWCLIPBOARD:
		if (hwndNextViewer)
			SendMessage(hwndNextViewer,message,wParam,lParam);
		if (MonitorClipboard)
		{
			if (IsClipboardFormatAvailable(CF_TEXT))
			{
				if (OpenClipboard(hWnd))
				{
					HGLOBAL hglbl;
					LPTSTR str;
					if (hglbl=GetClipboardData(CF_TEXT))
					{
						if (str=(char*)GlobalLock(hglbl))
						{
							RunCode(str,FALSE);
							GlobalUnlock(hglbl);
						}
					}
					CloseClipboard();
				}
			}
		}
		break;

	case WM_MOUSEMOVE:
		if (DontAutohide&&!ShowingPin)
		{
			RECT r;
			ShowingPin=TRUE;
			GetClientRect(hWnd,&r);
			hdc=GetDC(hWnd);
			DrawIcon(hdc,r.right-32,0,hPin);
			ReleaseDC(hWnd,hdc);
			KillTimer(hWnd,1);
		}
		break;

	case WM_LBUTTONUP:
		KillTimer(hWnd,1);
		ShowWindow(hWnd,SW_HIDE);
		break;

	case WM_TIMER:
		switch(wParam)
		{
		case 1:		// AutoHide timer
			KillTimer(hWnd,1);
			ShowWindow(hWnd,SW_HIDE);
			break;
		case 2:		// Append timer
			KillTimer(hWnd,2);
			strcpy(CurCode,"");
			break;
		}
		break;

	case TRAY_NOTIFYICON:
		switch (lParam)
		{
/*		case WM_LBUTTONDBLCLK:
			if (!OptionsDialogOpen)
			{
				DialogBox(ghInst,MAKEINTRESOURCE(IDD_OPTIONS),hWnd,OptionsProc);
			}
			break;*/
		case WM_RBUTTONUP:
			{
				POINT p;
				GetCursorPos(&p);
				switch (TrackPopupMenu(GetSubMenu(LoadMenu(ghInst,MAKEINTRESOURCE(IDR_POPUP)),0),
					TPM_RIGHTALIGN|TPM_NONOTIFY|TPM_RETURNCMD,p.x,p.y,0,hWnd,NULL))
				{
				case ID_CLOSE:
					SendMessage(hWnd,WM_DESTROY,0,0);
					break;
				case ID_OPTIONS:
					if (!OptionsDialogOpen)
					{
						DialogBox(ghInst,MAKEINTRESOURCE(IDD_OPTIONS),hWnd,OptionsProc);
					}
					break;
				case ID_ABOUT:
					if (!AboutDialogOpen)
					{
						DialogBox(ghInst,MAKEINTRESOURCE(IDD_ABOUT),hWnd,AboutProc);
					}
					break;
				case ID_ENTERDC2:
					if (!EnterDC2DialogOpen)
					{
						DialogBox(ghInst,MAKEINTRESOURCE(IDD_ENTERDC2),hWnd,EnterDC2Proc);
					}
					break;
				case ID_RESHOW:
					if (strlen(output))
						ShowWindow(hWnd,SW_SHOW);
					break;
				}
			}
			break;
		}
		break;

	default:
		if(message==s_uTaskbarRestart)
			AddTaskbarIcons();
		return (DefWindowProc(hWnd, message, wParam, lParam));
	}
	return 0;
}

void AddTaskbarIcons(void)
{
	TrayIconAdd(ghWnd,1,StatusIcons[CurrentStatus],CurrentTip);
}

void SetTaskbarIcon(int state, char tip[])
{
	CurrentStatus=state;
	if (strlen(tip)<64)
		strcpy(CurrentTip,tip);
	else
	{
		strncpy(CurrentTip,tip,60);
		strcat(CurrentTip,"...");
	}
	TrayIconModify(ghWnd,1,StatusIcons[CurrentStatus],CurrentTip);
}

BOOL TrayMessage(HWND hwnd, DWORD msg, UINT id, HICON hIcon, PTSTR tip)
{
	NOTIFYICONDATA tnd;

	tnd.cbSize=sizeof(NOTIFYICONDATA);
	tnd.hWnd=hwnd;
	tnd.uID=id;
	tnd.uFlags=NIF_MESSAGE|NIF_ICON|NIF_TIP;
	tnd.uCallbackMessage=TRAY_NOTIFYICON;
	tnd.hIcon=hIcon;
	//tnd.szTip[0]='\0';
	lstrcpyn(tnd.szTip, tip, sizeof(tnd.szTip));
	return Shell_NotifyIcon(msg,&tnd);
}

void TrayIconDelete(HWND hwnd, UINT id, HICON hIcon)
{
	TrayMessage(hwnd,NIM_DELETE,id,hIcon,NULL);
}

void TrayIconModify(HWND hwnd, UINT id, HICON hIcon, PTSTR tip)
{
	TrayMessage(hwnd,NIM_MODIFY,id,hIcon,tip);
}

void TrayIconAdd(HWND hwnd, UINT id, HICON hIcon, PTSTR tip)
{
	TrayMessage(hwnd,NIM_ADD,id,hIcon,tip);
}

int InitInstance(void)
{
	WNDCLASS wc;

	// Create window class
	wc.style         = CS_HREDRAW|CS_VREDRAW;
	wc.lpfnWndProc   = (WNDPROC) WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = ghInst;
	wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wc.hIcon		 = LoadIcon(ghInst, MAKEINTRESOURCE(IDI_MAIN));
	wc.hbrBackground = (HBRUSH)CreateSolidBrush(RGB(255,255,192));
	wc.lpszMenuName  = NULL;
	wc.lpszClassName = "DCDecoderWC";

	// Register window class
	if(RegisterClass(&wc) == 0)
		return -1;
	return 0;
}

int InitApplication(void)
{
	// Create the application window
	ghWnd=CreateWindowEx(WS_EX_TOPMOST, "DCDecoderWC", "Dragon Code Decoder",
		WS_POPUP,
		0, 0, 100, 100,
		NULL, NULL, ghInst, NULL);

	if (ghWnd==NULL)
		return -1;

	return 0;
}

int APIENTRY WinMain(HINSTANCE hInstance,
					 HINSTANCE hPrevInstance,
					 LPSTR lpCmdLine,
					 int nCmdShow)
{
	MSG msg;

	ghInst=hInstance;

	// Am I already running?
	if (FindWindow("DCDecoderWC","Dragon Code Decoder"))
		return 0;

	// Init all instances
	if (!hPrevInstance)
		if (InitInstance()==-1)
			return FALSE;
	// Init this instance
	if (InitApplication()==-1)
		return FALSE;

	// The message loop
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}
